/*
 * Copyright (c) 1997 Silicon Graphics, Inc.  All Rights Reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it would be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Further, this software is distributed without any warranty that it is
 * free of the rightful claim of any third person regarding infringement
 * or the like.  Any license provided herein, whether implied or
 * otherwise, applies only to this software file.  Patent licenses, if
 * any, provided herein do not apply to combinations of this program with
 * other software, or any other product whatsoever.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write the Free Software Foundation, Inc., 59
 * Temple Place - Suite 330, Boston MA 02111-1307, USA.
 * 
 * Contact information: Silicon Graphics, Inc., 1600 Amphitheatre Pkwy,
 * Mountain View, CA  94043, or:
 * 
 * http://www.sgi.com 
 * 
 * For further information regarding this notice, see: 
 * 
 * http://oss.sgi.com/projects/GenInfo/SGIGPLNoticeExplan/
 *
 * $Id: trace_hash.h,v 1.9 1997/07/16 20:26:22 kenmcd Exp $
 */

#ifndef _TRACE_HASH_H
#define _TRACE_HASH_H

#ifdef __cplusplus      
extern "C" {
#endif

typedef int  (*__pmHashCmpFunc)(void *, void *);
typedef int  (*__pmHashKeyCmpFunc)(void *, const char *);
typedef void (*__pmHashDelFunc)(void *);

struct __pmHashEl {
    void		*ent;
    struct __pmHashEl	*next;
};
typedef struct __pmHashEl __pmHashEnt;

typedef struct {
    size_t		tsize;
    size_t		esize;
    unsigned int	entries;
    __pmHashCmpFunc	cmp;
    __pmHashDelFunc	del;
    __pmHashEnt		**rows;
    /*void		**pool;*/
} __pmHashTable;

extern int __pmhashinit(__pmHashTable *, size_t, size_t, __pmHashCmpFunc, __pmHashDelFunc);

extern void __pmhashtrunc(__pmHashTable *);

extern int __pmhashinsert(__pmHashTable *, const char *, void *);

extern void *__pmhashlookup(__pmHashTable *, const char *, void *);

typedef void (*__pmHashIterFunc)(__pmHashTable *, void *);
extern void __pmhashtraverse(__pmHashTable *, __pmHashIterFunc);

#ifndef PM_HASH_TUNE
#define PM_HASH_SHFT	5
#define PM_HASH_SIZE	31
#endif

#ifdef __cplusplus      
}
#endif

#endif /* _TRACE_HASH_H */
